mode(-1);
clear
exec loader.sce

x=rand(1,100);
y=rand(1,100);
z=rand(1,100);

new_x = rand(1,10);
new_y = rand(1,10);
new_z = rand(1,10);

constraints=[1 1 5 1;...
						 5 1 7 3;...
						 7 3 4 4;...
						 4 4 3 6;...
						 3 6 1 5;...
						 1 5 1 1;...
						 5 2 5 3;...
 						 5 3 3 4;...
						 3 4 2 2;...
						 2 2 5 2];

printf("*********************************************\n");
printf("*****      DOING TESTS IN CGLAB-0.9       *******\n");
printf("*********************************************\n");

printf("\n\n");
printf("------------------------------------------\n");
printf("-----     testing cgal_convex_hull_2:   ------\n");
printf("------------------------------------------\n");
printf("\n\n");

[hull,ind]=cgal_convex_hull_2([x;y]);
[nbrows,nb_extrimal_points]=size(ind);

if hull == nb_extrimal_points  then
	printf("convex_hull_2d is \t\tOK\n");
end

printf("\n\n");
printf("------------------------------------------\n");
printf("-----     testing cgal_delaunay_2:    ----\n");
printf("------------------------------------------\n");
printf("\n\n");

[tri,ptr] = cgal_delaunay_2(x,y);


tri2 = cgal_dt2_get_connectivity(ptr);
if tri == tri2 then
	printf("cgal_dt2_get_connectivity is \t\tOK\n");
	else printf("cgal_dt2_get_connectivity is not \t\tOK\n");
end

cgal_dt2_insert_points(ptr,new_x,new_y);
tri3 = cgal_dt2_get_connectivity(ptr);
if tri3 == tri then
	printf("cgal_dt2_insert_points is not \t\tOK\n");
	else printf("cgal_dt2_insert_points is \t\tOK\n");
end

cgal_dt2_remove_points(ptr,new_x,new_y);
tri4 = cgal_dt2_get_connectivity(ptr);

if size(tri4) == size(tri2) then
	printf("cgal_dt2_remove_points is \t\tOK\n");
	else printf("cgal_dt2_remove_points is not \t\tOK\n");
end
cgal_dt2_delete(ptr);
printf("cgal_dt2_delete(ptr) is used\n");
printf("trying to insert points by using ptr even if is deleted\n");
//cgal_dt2_insert_points(ptr,new_x,new_y);
printf("trying to remove points by using ptr even if is deleted\n");
//cgal_dt2_remove_points(ptr,x,y);


printf("\n\n");
printf("------------------------------------------\n");
printf("-----     testing cgal_delaunay_3:    ----\n");
printf("------------------------------------------\n");
printf("\n\n");

[tes,ptr2] = cgal_delaunay_3(x,y,z);
tes2 = cgal_dt3_get_connectivity(ptr2);

if tes == tes2 then
	printf("cgal_dt3_get_connectivity is \t\tOK\n");
	else printf("cgal_dt3_get_connectivity is not \t\tOK\n");
end

cgal_dt3_insert_points(ptr2,new_x,new_y,new_z);
tes3= cgal_dt3_get_connectivity(ptr2);

if size(tes3) == size(tes) then
	printf("insert_points_3d is not \t\tOK\n");
	else printf("insert_points_3d is \t\tOK\n");
end

cgal_dt3_remove_points(ptr2,new_x,new_y,new_z);
tes4 = cgal_dt3_get_connectivity(ptr2);

if size(tes4) == size(tes) then
	printf("cgal_dt3_remove_points is \t\tOK\n");
	else printf("cgal_dt3_remove_points is not \t\tOK\n");
end

cgal_dt3_delete(ptr2);
printf("cgal_dt3_delete(ptr) is used\n");
printf("trying to insert points by using a deleted pointer\n");
//cgal_dt3_insert_points(ptr2,new_x,new_y,new_z);
printf("trying to remove points by using a deleted pointer\n");
//cgal_dt3_remove_points(ptr2,x,y,z);

printf("\n\n");
printf("------------------------------------------\n");
printf("-----     testing cgal_delaunay_n:    ----\n");
printf("------------------------------------------\n");
printf("\n\n");

[tri_2d,pt_2d]= cgal_delaunay_n([x' y']);
tri_2d_2 = cgal_dtn_get_connectivity(pt_2d);

printf("comparing with the result of delaunay_2d\n");
if size(tri) == size(tri_2d) then
	printf("cgal_delaunay_n is \t\tOK\n");
	else printf("cgal_delaunay_n is not \t\tOK\n");
end

if tri_2d_2 == tri_2d then
	printf("cgal_dtn_get_connectivity is \t\tOK\n");
	else printf("cgal_dtn_get_connectivity is not \t\tOK\n");
end

cgal_dtn_insert_points(pt_2d,[new_x' new_y']);
tri_2d_3= cgal_dtn_get_connectivity(pt_2d);

if size(tri_2d_3) == size(tri_2d) then
	printf("cgal_dtn_insert_points is not \t\tOK\n");
	else printf("cgal_dtn_insert_points is \t\tOK\n");
end

printf("trying to insert points by using a deleted pointer\n");
cgal_dtn_delete(pt_2d);
//cgal_dtn_insert_points(pt_2d,[new_x' new_z']); <------------------- ce test pose un probleme.

//

printf("\n\n");
printf("------------------------------------------\n");
printf("--- testing cgal_constraind_delaunay_2:   ----\n");
printf("------------------------------------------\n");
printf("\n\n");

[ctri,cptr]=cgal_constraind_delaunay_2([],[],constraints);
ctri2 = cgal_cdt2_get_connectivity(cptr);

if ctri == ctri2 then
	printf("cgal_cdt2_get_connectivity is \t\tOK\n");
	else printf("cgal_cdt2_get_connectivity is not \t\tOK\n");
end

cgal_cdt2_insert_points(cptr,new_x*2,new_y*3);
ctri3 = cgal_cdt2_get_connectivity(cptr);
coord = cgal_cdt2_get_coord(cptr);

if size(ctri3) == size(ctri) then
	printf("cgal_cdt2_insert_points is not \t\tOK\n");
	else printf("cgal_cdt2_insert_points is \t\tOK\n");
end

cgal_cdt2_remove_points(cptr,new_x*2,new_y*3);
ctri4 = cgal_cdt2_get_connectivity(cptr);

if size(ctri4) == size(ctri) then
	printf("cgal_cdt2_remove_points is \t\tOK\n");
	else printf("cgal_cdt2_remove_points is not\t\tOK\n");
end
//--------------
cgal_cdt2_insert_points(cptr,[1 3 3 3],[2 5 5 6]);
ctri_mc = cgal_cdt2_get_connectivity(cptr);
cgal_cdt2_remove_points(cptr,[1 3 3 3],[2 5 5 6]);
//---------------
cgal_cdt2_insert_constraints(cptr,[1 2 3 5;3 5 3 6]);
ctri5 = cgal_cdt2_get_connectivity(cptr);

if size(ctri5) == size(ctri4) then
	printf("cgal_cdt2_insert_constraints is\t\tNOT OK\n");
	else printf("cgal_cdt2_insert_constraints is \t\tOK\n");
end

cgal_cdt2_remove_constraints(cptr,[1 2 3 5;3 5 3 6]);
ctri6 = cgal_cdt2_get_connectivity(cptr);

if size(ctri6) == size(ctri_mc)&size(ctri6) != size(ctri5) then
	printf("cgal_cdt2_remove_constraints is \t\tOK\n");
	else printf("cgal_cdt2_remove_constraints is\t\tNOT OK\n");
end


printf("trying to insert points by using a deleted pointer\n");

//cgal_cdt2_delete(cptr,"cptr");
//cgal_cdt2_insert_points(cptr,new_x,new_y);   <---------------- ceci ne marche pas.

printf("\n\n");
printf("------------------------------------------\n");
printf("-----     testing cgal_mesh_2:       -------\n");
printf("------------------------------------------\n");
printf("\n\n");

[coord,connect,ptr_to_mesh]=cgal_mesh_2(constraints);

coord2 = cgal_mesh2_get_coord(ptr_to_mesh);
connect2 = cgal_mesh2_get_connectivity(ptr_to_mesh);

if coord2 == coord then
	printf("cgal_mesh2_get_coord is \t\tOK\n");
	else printf("cgal_mesh2_get_coord is not \t\tOK\n");
end

if connect2 == connect then
	printf("cgal_mesh2_get_connectivity is \t\tOK\n");
	else printf("cgal_mesh2_get_connectivity is not \t\tOK\n");
end

cgal_mesh2_set_seeds(ptr_to_mesh,3,2.5);

cgal_mesh2_refine(ptr_to_mesh,0.1,0.5);
//cgal_mesh2_refine(ptr_to_mesh,0.0001,0.00915); //<-------------
coord = cgal_mesh2_get_coord(ptr_to_mesh);
connect = cgal_mesh2_get_connectivity(ptr_to_mesh);

// if connect2 == connect then
// 	printf("cgal_mesh2_get_connectivity is \t\tOK\n");
// 	else printf("cgal_mesh2_get_connectivity is not \t\tOK\n");
// end
// cgal_mesh2_get_coord
// cgal_mesh2_refine
// cgal_mesh2_set_seeds
printf("------------------------------------------\n");
