mode(-1);

UNIXLIB = 'libCGLAB.so'
WINLIB = 'libCGLAB.lib'

LIB_OBJS = 'convex_hull.o '+..
 	       'Delaunay_2d.o '+..
           'Delaunay_3d.o '+..
           'Delaunay_nd.o '+..
           'Constrained_Delaunay.o '+..
		   'scilab_job.o '+..
           'Delaunay_mesher.o '
//Fichiers objet pour Windows
LIBOBJSWIN = strsubst(LIB_OBJS,'.o','.obj')


disp('Making all in CGLAB-0.9 library ');
disp('be patient, this may take a while');


// Generic part to get the absolute contribution path
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1
	l=strindex(nams(k),'builder.sce');
	if l<>[] then
		DIR=part(nams(k),1:l($)-1);
		break
	end
end


//---------------------------------------------------------------------
// Under Unix and Linux systems
//---------------------------------------------------------------------
if ~MSDOS then
	if part(DIR,1)<>'/' then
		DIR=getcwd()+'/'+DIR
	end

	// Path of the C-source files directory
	SOURCE=DIR+'src/'

	// Create Makefile for source files
	u=file('open',SOURCE+'Makefile','unknown')
	write(u,['#----------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#----------------------------------------------------------------------'
		'include $(CGAL_MAKEFILE)                                               '
		'#---------------------------------------------------------------------#'
		'#                    compiler flags'
		'#---------------------------------------------------------------------#'
		'SCIDIR = '+SCI
		'CXXFLAGS = \'
		          '          -I../..include \'
		          '          $(CGAL_CXXFLAGS) \'
		          '          $(LONG_NAME_PROBLEM_CXXFLAGS)\'
				  '           -I'+SCI+'/routines'
		'LIBTIFFDIR = '+DIR
		'LIBRARY = '+UNIXLIB // Object file library
		'OBJSC = '+LIB_OBJS //C objects
		'include '+SCI+'/Makefile.incl'
		'CFLAGS = $(CC_OPTIONS) $(CC_PICFLAGS) $(CXXFLAGS)'
		'LIBPATH = \'
		         '       $(CGAL_LIBPATH)'
		'LDFLAGS = \'
		         '       $(LONG_NAME_PROBLEM_LDFLAGS) \'
			 '       $(CGAL_LDFLAGS)'

		'OBJS = $(OBJSC) $(OBJSF)'

		'all:: $(LIBRARY)'
		'$(LIBRARY): $(OBJS)'
			'	@echo Creation of $(LIBRARY)'
			'	$(CC) $(LIBPATH) -shared -o $(LIBRARY) $(OBJS) $(CC_LDFLAGS)  $(LDFLAGS)'

			],'(a)')


	file('close',u)
	cmd_make_lib='make'

else
//---------------------------------------------------------------------
// Under Windows systems
//---------------------------------------------------------------------
if part(DIR,2)<>':' then
		DIR=getcwd()+'\'+DIR
	end
	// Path of the macros directory
	MACROS=DIR+'macros\'

	// Path of the C-source files directory
  	SOURCE=DIR+'src\'

	// Scilab path under Windows
  	SCI_WIN=strsubst(SCI,'/','\')

	// Create Makefile
	disp('Creating Makefile')
  	u=file('open',SOURCE+'Makefile','unknown')
  	tab=code2str(-40)

	write(u,['#---------------------------------------------------------------------'
		'# This file has been generated by builder.sce'
		'# Please do not edit this file!'
		'#---------------------------------------------------------------------'
		'CGAL_CXXFLAGS =/O2 /D ""WIN32"" /D ""NDEBUG"" /D ""CGAL_USE_GMP"" /D ""_MBCS"" /FD /EHsc /GS /ML /GR /W2 /nologo /c /TP'
  		'LIBPATH = /LIBPATH:""$(CGALROOT)\lib\msvc7"" CGAL.lib'
  		'SCIDIR = ""'+SCI_WIN+'""'
  		'LIB = lib'
  		'LIBRARY = '+WINLIB // Object file library
  		'OBJSF = ' // Fortran objects files
  		'OBJSC = '+LIBOBJSWIN //C objects files
  		'include ..\..\..\Makefile.incl.mak'

  		'CFLAGS = $(CC_OPTIONS) -DFORDLL -I""$(CGALROOT)\include\CGAL\config\msvc7"" -I""$(CGALROOT)\include"" -I""'+SCI_WIN+'\routines"" $(CGAL_CXXFLAGS)'
  		'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI_WIN+'\routines""'
  		' '
  		'all :: '+WINLIB // Dynamic library
  		' '
  		WINLIB+' : $(OBJSC)'
		tab+'@$(LIB) /out:'+WINLIB+' $(LIBPATH) $(OBJSC)'],'(a)')
 		file('close',u)

  		cmd_make_lib='nmake /f Makefile'

end
	OLDDIR=getcwd();
	chdir(SOURCE)
	disp('Compiling library')
	unix_s(cmd_make_lib)
	chdir(OLDDIR);
	disp('CGLAB-0.9 compiled')

